import { INode, Type, IContext, IValidationResult, IAnyType } from "../../internal";
export declare class Late<C, S, T> extends Type<C, S, T> {
    readonly definition: () => IAnyType;
    private _subType;
    readonly flags: number;
    readonly shouldAttachNode: boolean;
    getSubType(mustSucceed: true): IAnyType;
    getSubType(mustSucceed: false): IAnyType | null;
    constructor(name: string, definition: () => IAnyType);
    instantiate(parent: INode | null, subpath: string, environment: any, snapshot: any): INode;
    reconcile(current: INode, newValue: any): INode;
    describe(): string;
    isValidSnapshot(value: any, context: IContext): IValidationResult;
    isAssignableFrom(type: IAnyType): boolean;
}
export declare function late<T extends IAnyType>(type: () => T): T;
export declare function late<T extends IAnyType>(name: string, type: () => T): T;
export declare function isLateType<IT extends IAnyType>(type: IT): type is IT;
